#include "FlowManagement.h"
#include "FlowLoadLayer.h"
#include "FlowMenuLayer.h"
#include "FlowSelectSectionLayer.h"
#include "FlowSectionSelectLayer.h"
#include "FlowGameLayer.h"
#include "FlowGameMenuLayer.h"
#include "SimpleAudioEngine.h"
#include "FlowSelectLevelLayer.h"

using namespace cocos2d;
CFlowManagement::CFlowManagement(void)
{
}


CFlowManagement::~CFlowManagement(void)
{
}

void CFlowManagement::goLoadLayer()
{
	m_loadScene=CCScene::create();
	CFlowSelectSectionLayer *loadLayer= CFlowSelectSectionLayer::create();
	loadLayer->fm=this;
	m_loadScene->addChild(loadLayer);
}


void CFlowManagement::goMenuLayer()
{
	m_menuScene=CCScene::create();
	CFlowMenuLayer *menuLayer=CFlowMenuLayer::create();
	menuLayer->fm=this;
	m_menuScene->addChild(menuLayer);
	//лЧ
	CCTransitionScene *ccts=CCTransitionFade::create(1.5,m_menuScene,Color3B(ccc3(255,255,255)));
	CCDirector::sharedDirector()->replaceScene(ccts);
}


void CFlowManagement::goGameLayer()
{
	if (CCUserDefault::sharedUserDefault()->getBoolForKey("isSoundOn"))
	{
	}
	m_gameScene=CCScene::create();
	CFlowGameLayer *gameLayer=CFlowGameLayer::create();
	m_gameScene->addChild(gameLayer);
	//лЧ
	CCTransitionScene *ccts=CCTransitionFade::create(1.5,m_gameScene, Color3B(ccc3(255, 255, 255)));
	CCDirector::sharedDirector()->replaceScene(ccts);
}



void CFlowManagement::goSelectSectionLayer()
{
	m_selectsectionScene=CCScene::create();
	CFlowSelectSectionLayer *selectsectionLayer=CFlowSelectSectionLayer::create();
	selectsectionLayer->fm=this;
	m_selectsectionScene->addChild(selectsectionLayer);
	//лЧ
	CCTransitionScene *ccts=CCTransitionFade::create(1.5,m_selectsectionScene, Color3B(ccc3(255, 255, 255)));
	CCDirector::sharedDirector()->replaceScene(ccts);

}


void CFlowManagement::goSectionSelectLayer()
{
	m_sectionselectScene=CCScene::create();
	//CFlowSectionSelectLayer *sectionselectLayer=CFlowSectionSelectLayer::create();
	FlowSelectLevelLayer *sectionselectLayer = FlowSelectLevelLayer::create();
	sectionselectLayer->fm=this;
	m_sectionselectScene->addChild(sectionselectLayer);
	//лЧ
	CCTransitionScene *ccts=CCTransitionFade::create(1.5,m_sectionselectScene, Color3B(ccc3(255, 255, 255)));
	CCDirector::sharedDirector()->replaceScene(ccts);


}