#include "FlowSelectSectionLayer.h"
#include "Mydata.h"
#include "SimpleAudioEngine.h"
#include"UIUtils.h"
#include"HallScene.h"
#include "PlatformUtil.h"
using namespace CocosDenshion;
extern int whichGame;

CFlowSelectSectionLayer::CFlowSelectSectionLayer(void)
{
	CCLOG("selectSectionLayer");
}


CFlowSelectSectionLayer::~CFlowSelectSectionLayer(void)
{
}

bool CFlowSelectSectionLayer::init()
{
	bool bRet=false;
	setKeypadEnabled(true);
	do 
	{
		CC_BREAK_IF(!CCLayer::init());

		//ؿ
		CMydata pdata;
		pdata.isHaveSaveFile();
		initUserData();

		m_nCurPage=1;
		visibleSize=CCDirector::sharedDirector()->getVisibleSize();
		CCPoint origin=CCDirector::sharedDirector()->getVisibleOrigin();
		m_pMenu=CCMenu::create();
		pLayer=CCLayer::create();
		//ͼƬԴ
		CCSprite *pSprite=CCSprite::create("selectsection/bg.jpg");
		pSprite->setPosition(ccp(visibleSize.width/2,visibleSize.height/2));
		pSprite->setScale(0.75f);
		pLayer->addChild(pSprite);

		pSprite->setTexture("hallScene/hall_bg.png");
		//
		Button* back = Button::create("hallScene/hall_4.png","hallScene/hall_5.png");
		back->setPosition(Vec2(80,visibleSize.height*0.9));
		back->setScale(0.75f);
		back->addClickEventListener([=](Ref*) {
			xGetNative();
			DIRECTOR->replaceScene(HallScene::createScene());
		});
		pLayer->addChild(back);
		//Ϸ
		Button* jieshao = Button::create("hallScene/hall_8.png", "hallScene/hall_9.png");
		jieshao->setPosition(Vec2(visibleSize.width -80, visibleSize.height*0.9));
		jieshao->addClickEventListener([=](Ref*) {
			addJieshao();
		});
		jieshao->setScale(0.75f);
		pLayer->addChild(jieshao);


		CCSprite *pSprite1=CCSprite::create("selectsection/logo.png");
		pSprite1->setPosition(ccp(visibleSize.width/2,visibleSize.height-120));
		pSprite1->setScale(0.75f);
		pLayer->addChild(pSprite1);
		//ѡϷఴť
		CCMenuItemImage *pItem1=CCMenuItemImage::create(
			"selectsection/but1.png",
			"selectsection/but1_1.png",
			this,
			menu_selector(CFlowSelectSectionLayer::goToSectionSelect)
			);
		pItem1->setPosition(ccp(visibleSize.width/2,visibleSize.height/2+300));

		CCMenuItemImage *pItem2=CCMenuItemImage::create(
			"selectsection/but2.png",
			"selectsection/but2_1.png",
			this,
			menu_selector(CFlowSelectSectionLayer::goToSectionSelect)
			);
		pItem2->setPosition(ccp(visibleSize.width/2,visibleSize.height/2+100));

		CCMenuItemImage *pItem3=CCMenuItemImage::create(
			"selectsection/but3.png",
			"selectsection/but3_1.png",
			this,
			menu_selector(CFlowSelectSectionLayer::goToSectionSelect)
			);
		pItem3->setPosition(ccp(visibleSize.width/2,visibleSize.height/2-100));

		CCMenuItemImage *pItem4=CCMenuItemImage::create(
			"selectsection/but4.png",
			"selectsection/but4_1.png",
			this,
			menu_selector(CFlowSelectSectionLayer::goToSectionSelect)
			);
		pItem4->setPosition(ccp(visibleSize.width/2,visibleSize.height/2-300));

		CCMenuItemImage *pItem5=CCMenuItemImage::create(
			"selectsection/but5.png",
			"selectsection/but5_1.png",
			this,
			menu_selector(CFlowSelectSectionLayer::goToSectionSelect)
			);
		pItem5->setPosition(ccp(visibleSize.width/2,visibleSize.height/2-500));

		m_pMenu=CCMenu::create(pItem1,pItem2,pItem3,pItem4,pItem5,NULL);
		m_pMenu->setPosition(Vec2(0, 0));
		m_pMenu->setScale(0.75f);
		pLayer->addChild(m_pMenu,2);
	

		//for (int i = 0; i < 5; i++)
		//{
		//	Label* label1 = Label::createWithSystemFont("80", "", 40);
		//	label1->setColor(Color3B::BLACK);
		//	label1->setPosition(Vec2(visibleSize.width / 2, visibleSize.height / 2 + 300 - i+200));
		//	pLayer->addChild(label1, 10);
		//}
		displayLabel();

		//ͼС
		m_pScrollView= extension::ScrollView::create(CCSizeMake(540,960),pLayer);
		//ƫ
		m_pScrollView->setContentOffset(Vec2(0, 0));
		//ͷ
//		m_pScrollView->setDelegate(this);
		//ǷԼдϢfalseΪҪtureΪҪ
		m_pScrollView->setTouchEnabled(false);
		//Ƿܹ϶
		m_pScrollView->setBounceable(true);
		//
		m_pScrollView->setDirection(cocos2d::extension::ScrollView::Direction::HORIZONTAL);
		//m_pScrollView->setDirection(ui::ScrollView::Direction::HORIZONTAL);
		//С
		pLayer->setContentSize(CCSizeMake(540*2,800));
		this->addChild(m_pScrollView);
		
		//ӵײҳʶ
		//for (int i=1;i<=2;i++)
		//{
		//	CCSprite *pageControlSprite=CCSprite::create("selectsection/smalldot.png");
		//	pageControlSprite->setPosition(
		//		ccp
		//		(
		//		visibleSize.width/2-3*pageControlSprite->getContentSize().width/2+pageControlSprite->getContentSize().width*(i-1),
		//		origin.y+30
		//		)
		//		);
		//	pageControlSprite->setTag(100+i);
		//	this->addChild(pageControlSprite,1);
		//}
		////ʼ״̬һΪѡ
		//CCSprite *selectedSprite=(CCSprite *)this->getChildByTag(101);
		//CCTexture2D *aTexttrue=CCTextureCache::sharedTextureCache()->addImage("selectsection/bigdot.png");
		//selectedSprite->setTexture(aTexttrue);

		//֡ķʽ
		//CCSpriteFrameCache *pCache=CCSpriteFrameCache::sharedSpriteFrameCache();
		//pCache->addSpriteFrame(CCSpriteFrame::create("smalldot.png",CCRectMake(0,0,64,64)),"smalldot.png");
		//pCache->addSpriteFrame(CCSpriteFrame::create("bigdot.png",CCRectMake(0,0,64,64)),"bigdot.png");
		//for (int i=1;i<=3;i++)
		//{
		// CCSprite *pPoint = CCSprite::createWithSpriteFrameName("smalldot.png");
		// pPoint->setTag(i);
		// pPoint->setPosition(ccp( origin.x + (visibleSize.width - 3 * pPoint->getContentSize().width)/2 + pPoint->getContentSize().width * (i-1), origin.y + 30));
		// this->addChild(pPoint);
		//}
		//CCSprite *pPoint = (CCSprite *)this->getChildByTag(1);
		//pPoint->setDisplayFrame(pCache->spriteFrameByName("bigdot.png"));

		bRet=true;

	} while (0);



	return true;
}
void CFlowSelectSectionLayer::addJieshao()
{
	Layout* layout = Layout::create();
	layout->setSize(visibleSize);
	layout->setColor(Color3B::GRAY);
	pLayer->addChild(layout,100);

	CCSprite *pSprite = CCSprite::create("selectsection/jieshao.png");
	pSprite->setPosition(ccp(visibleSize.width / 2, visibleSize.height / 2-50));
	pSprite->setScale(0.75f);
	layout->addChild(pSprite);

	Size sp_size = pSprite->getContentSize();

	Button* set = Button::create("hallScene/hall_2.png", "hallScene/hall_3.png");
	set->setPosition(Vec2(sp_size.width -50 , sp_size.height-50));
	set->addClickEventListener([=](Ref*) {
		layout->removeFromParent();
	});
	pSprite->addChild(set);
}
void CFlowSelectSectionLayer::displayLabel()
{
	//ؿʾ
	char num[10],maxNum[10];
	sprintf(num, "%d", 80);
	//
	Label* label_1 = Label::createWithCharMap("selectlevel/num.png", 26, 43, '0');
	label_1->setString(num);
	label_1->setScale(0.75f);
	label_1->setPosition(Vec2(visibleSize.width / 2 + 90, visibleSize.height / 2 + 230));
	pLayer->addChild(label_1, 10);

	int fiveMax = UserDefault::getInstance()->getIntegerForKey("flow_five_max_level");
	sprintf(maxNum, "%d", fiveMax);
	Label* label1 = Label::createWithCharMap("selectlevel/num.png", 26, 43, '0');
	label1->setString(maxNum);
	label1->setScale(0.75f);
	label1->setPosition(Vec2(visibleSize.width / 2 +30, visibleSize.height / 2 + 230));
	pLayer->addChild(label1, 10);

	Label* label_2 = Label::createWithCharMap("selectlevel/num.png", 26, 43, '0');
	label_2->setString(num);
	label_2->setScale(0.75f);
	label_2->setPosition(Vec2(visibleSize.width / 2 + 90, visibleSize.height / 2 + 80));
	pLayer->addChild(label_2, 10);

	int sixMax = UserDefault::getInstance()->getIntegerForKey("flow_six_max_level");
	sprintf(maxNum, "%d", sixMax);
	Label* label2 = Label::createWithCharMap("selectlevel/num.png", 26, 43, '0');
	label2->setString(maxNum);
	label2->setScale(0.75f);
	label2->setPosition(Vec2(visibleSize.width / 2+30, visibleSize.height / 2 + 80));
	pLayer->addChild(label2, 10);

	Label* label_3 = Label::createWithCharMap("selectlevel/num.png", 26, 43, '0');
	label_3->setString(num);
	label_3->setScale(0.75f);
	label_3->setPosition(Vec2(visibleSize.width / 2 + 90, visibleSize.height / 2 - 70));
	pLayer->addChild(label_3, 10);

	int sevenMax = UserDefault::getInstance()->getIntegerForKey("flow_seven_max_level");
	sprintf(maxNum, "%d", sevenMax);
	Label* label3 = Label::createWithCharMap("selectlevel/num.png", 26, 43, '0');
	label3->setString(maxNum);
	label3->setScale(0.75f);
	label3->setPosition(Vec2(visibleSize.width / 2 + 30, visibleSize.height / 2 - 70));
	pLayer->addChild(label3, 10);

	Label* label_4 = Label::createWithCharMap("selectlevel/num.png", 26, 43, '0');
	label_4->setString(num);
	label_4->setScale(0.75f);
	label_4->setPosition(Vec2(visibleSize.width / 2 + 120, visibleSize.height / 2 - 220));
	pLayer->addChild(label_4, 10);

	int eightMax = UserDefault::getInstance()->getIntegerForKey("flow_eight_max_level");
	sprintf(maxNum, "%d", eightMax);
	Label* label4 = Label::createWithCharMap("selectlevel/num.png", 26, 43, '0');
	label4->setString(maxNum);
	label4->setScale(0.75f);
	label4->setPosition(Vec2(visibleSize.width / 2 + 60, visibleSize.height / 2 - 220));
	pLayer->addChild(label4, 10);

	Label* label_5 = Label::createWithCharMap("selectlevel/num.png", 26, 43, '0');
	label_5->setString(num);
	label_5->setScale(0.75f);
	label_5->setPosition(Vec2(visibleSize.width / 2 + 120, visibleSize.height / 2 - 370));
	pLayer->addChild(label_5, 10);

	int nineMax = UserDefault::getInstance()->getIntegerForKey("flow_nine_max_level");
	sprintf(maxNum, "%d", nineMax);
	Label* label5 = Label::createWithCharMap("selectlevel/num.png", 26, 43, '0');
	label5->setString(maxNum);
	label5->setScale(0.75f);
	label5->setPosition(Vec2(visibleSize.width / 2 + 60, visibleSize.height / 2 - 370));
	pLayer->addChild(label5, 10);
}
//void CFlowSelectSectionLayer::scrollViewDidScroll(CCScrollView *view){
//
//}
//void CFlowSelectSectionLayer::scrollViewDidZoom(CCScrollView *view)
//{
//
//}
void CFlowSelectSectionLayer::initUserData()
{
	if (UserDefault::getInstance()->getIntegerForKey("flow_five_max_level") == 0) {
		UserDefault::getInstance()->setIntegerForKey("flow_five_max_level", 1);
		UserDefault::getInstance()->flush();
	}
	if (UserDefault::getInstance()->getIntegerForKey("flow_six_max_level") == 0) {
		UserDefault::getInstance()->setIntegerForKey("flow_six_max_level", 1);
		UserDefault::getInstance()->flush();
	}
	if (UserDefault::getInstance()->getIntegerForKey("flow_seven_max_level") == 0) {
		UserDefault::getInstance()->setIntegerForKey("flow_seven_max_level", 1);
		UserDefault::getInstance()->flush();
	}
	if (UserDefault::getInstance()->getIntegerForKey("flow_eight_max_level") == 0) {
		UserDefault::getInstance()->setIntegerForKey("flow_eight_max_level", 1);
		UserDefault::getInstance()->flush();
	}
	if (UserDefault::getInstance()->getIntegerForKey("flow_nine_max_level") == 0) {
		UserDefault::getInstance()->setIntegerForKey("flow_nine_max_level", 1);
		UserDefault::getInstance()->flush();
	}
}
void CFlowSelectSectionLayer::onEnter()
{
	CCLayer::onEnter();
	//CCDirector::sharedDirector()->getTouchDispatcher()->addTargetedDelegate(this,0,true);  //¼
	addListenerEvent();
}
void CFlowSelectSectionLayer::onExit(){
	//CCDirector::sharedDirector()->getTouchDispatcher()->removeDelegate(this);
	CCLayer::onExit();
	
}
void CFlowSelectSectionLayer::addListenerEvent()
{
	//EventListenerTouchOneByOne *listener = EventListenerTouchOneByOne::create();
	//listener->setSwallowTouches(true); //ݴ
	//listener->onTouchBegan = CC_CALLBACK_2(CFlowSelectSectionLayer::onTouchBegan, this);
	//listener->onTouchMoved = CC_CALLBACK_2(CFlowSelectSectionLayer::onTouchMoved, this);
	//listener->onTouchEnded = CC_CALLBACK_2(CFlowSelectSectionLayer::onTouchEnded, this);
	//listener->onTouchCancelled = CC_CALLBACK_2(CFlowSelectSectionLayer::onTouchCancelled, this);
	////
	//Director::getInstance()->getEventDispatcher()->addEventListenerWithSceneGraphPriority(listener, this);

	//android back
	EventListenerKeyboard* l = EventListenerKeyboard::create();
	l->onKeyReleased = CC_CALLBACK_2(CFlowSelectSectionLayer::onKeyReleased, this);
	_eventDispatcher->addEventListenerWithSceneGraphPriority(l, this);
}
bool CFlowSelectSectionLayer::onTouchBegan(CCTouch *pTouch, CCEvent *pEvent){
	m_touchPoint=CCDirector::sharedDirector()->convertToGL(pTouch->getLocation());
	return true;
}
void CFlowSelectSectionLayer::onTouchMoved(CCTouch *pTouch, CCEvent *pEvent)
{

}
void CFlowSelectSectionLayer::onTouchEnded(CCTouch *pTouch, CCEvent *pEvent){
	CCPoint endPoint=CCDirector::sharedDirector()->convertToGL(pTouch->getLocation());
	float distance=endPoint.x-m_touchPoint.x;
	if (fabs(distance)>50)
	{
		adjustScrollView(distance);
	}

}
void CFlowSelectSectionLayer::onTouchCancelled(CCTouch *pTouch, CCEvent *pEvent){
	CCPoint endPoint=CCDirector::sharedDirector()->convertToGL(pTouch->getLocation());
	float distance=endPoint.x-m_touchPoint.x;
	if (fabs(distance)>50)
	{
		adjustScrollView(distance);
	}

}


void CFlowSelectSectionLayer::adjustScrollView(float offset){
	CCSize visibleSzie=CCDirector::sharedDirector()->getVisibleSize();
	CCPoint origin=CCDirector::sharedDirector()->getVisibleOrigin();
	//ԭʼҳҳʶΪѡ״̬

	CCSprite *pPoint=(CCSprite *)this->getChildByTag(100+m_nCurPage);
	CCTexture2D *NTexture=CCTextureCache::sharedTextureCache()->addImage("selectsection/smalldot.png");
	pPoint->setTexture(NTexture);
	if (offset<0)
	{
		m_nCurPage++;
	}else
	{
		m_nCurPage--;
	}

	if (m_nCurPage<1)
	{
		m_nCurPage=1;
	}

	if (m_nCurPage>2)
	{

	}
	else
	{
		pPoint=(CCSprite *)this->getChildByTag(m_nCurPage);
		//װɼ
		CCPoint adjustPos=ccp(origin.x-visibleSzie.width*(m_nCurPage-1),origin.y);
		m_pScrollView->setContentOffset(adjustPos,true);
		//õǰҳҳʶΪѡ״̬
		CCSprite *selectedSprite=(CCSprite *)this->getChildByTag(100+m_nCurPage);
		CCTexture2D *aTexture=CCTextureCache::sharedTextureCache()->addImage("selectsection/bigdot.png");
		selectedSprite->setTexture(aTexture);
	}
}


void CFlowSelectSectionLayer::goToSectionSelect(CCObject *pSender)
{
	if (CCUserDefault::sharedUserDefault()->getBoolForKey("isSoundOn"))
	{
		CocosDenshion::SimpleAudioEngine::sharedEngine()->playEffect("music/menu.mp3");
	}

	//if (!isChessLock)
	//{
	//	auto lock = LockNode::create();
	//	lock->setLockData(2);
	//	this->addChild(lock);
	//}

	CCMenuItem *pMenuItme=(CCMenuItem *)pSender;
	int nIdx=pMenuItme->getZOrder();
	//Ϸģʽ
	whichGame =nIdx;
	CCLOG("SelectSection:%d", whichGame);
	if (whichGame == 3)
	{
		
		fm->goSectionSelectLayer();
		
	}
	else if (whichGame == 4)
	{
		
		fm->goSectionSelectLayer();
		
	}
	else
	{		
		fm->goSectionSelectLayer();
	}

}

void CFlowSelectSectionLayer::onKeyReleased(EventKeyboard::KeyCode keyCode, Event* event)
{
	switch (keyCode)
	{
		//ؼ       
	case EventKeyboard::KeyCode::KEY_ESCAPE:
		DIRECTOR->replaceScene(HallScene::createScene());
	break;
	//menu        
	case EventKeyboard::KeyCode::KEY_MENU:
		break;
	}
}

void CFlowSelectSectionLayer::onkeyBackClicked()
{
	//fm->goMenuLayer();
	//xPressBack();
}