#include "FlowGameMenuLayer.h"
#include "FlowGameLayer.h"
//#include "Mydata.h"
#include "FlowLoseLayer.h"
CFlowGameMenuLayer::CFlowGameMenuLayer(void)
{
}


CFlowGameMenuLayer::~CFlowGameMenuLayer(void)
{
}

bool CFlowGameMenuLayer::init()
{
	if (!CCLayer::init())
	{
		return false;
	}
	m_Timelose=35;
	istimeOver=false;
	CCSize visiableSize=CCDirector::sharedDirector()->getVisibleSize();
	CCPoint origin=CCDirector::sharedDirector()->getVisibleOrigin();

	CCMenuItemImage *pReplay=CCMenuItemImage::create(
		"gamemenulayer/bg_refresh.png",
		"gamemenulayer/bg_refresh_pressed.png",
		this,
		menu_selector(CFlowGameMenuLayer::replay)
		);
	pReplay->setPosition(ccp(visiableSize.width*0.1,visiableSize.height*0.95));

	CCMenuItemImage *pMusicControl=CCMenuItemImage::create(
		"gamemenulayer/bg_music_off.png",
		"gamemenulayer/bg_music_on.png",
		this,
		menu_selector(CFlowGameMenuLayer::musicControl)
		);
    pMusicControl->setPosition(ccp(visiableSize.width*0.9,visiableSize.height*0.95));
	
	CCMenuItemImage *pSearchMore=CCMenuItemImage::create(
		"gamemenulayer/bg_gethelp.png",
		"gamemenulayer/bg_gethelp_pressed.png",
		this,
		menu_selector(CFlowGameMenuLayer::searchMore)
		);
	pSearchMore->setPosition(ccp(visiableSize.width*0.1,visiableSize.height*0.1));

	CCMenuItemImage *pSearch=CCMenuItemImage::create(
		"gamemenulayer/bg_help.png",
		"gamemenulayer/bg_help_pressed.png",
		this,
		menu_selector(CFlowGameMenuLayer::search)
		);
	pSearch->setPosition(ccp(visiableSize.width*0.78,visiableSize.height*0.1));

	m_pMenu=CCMenu::create(pReplay,pMusicControl,pSearch,pSearchMore,NULL);
	m_pMenu->setPosition(Vec2(0, 0));
	this->addChild(m_pMenu,2);

	CCSprite *pTop=CCSprite::create("gamemenulayer/bg_top.png");
	pTop->setPosition(ccp(visiableSize.width/2,visiableSize.height*0.9));
	this->addChild(pTop,1);
	CCSprite *pLevel=CCSprite::create("gamemenulayer/bg_level.png");
	pLevel->setPosition(ccp(visiableSize.width/2,visiableSize.height*0.95));
	this->addChild(pLevel,1);

	CCSprite *pBottom=CCSprite::create("gamemenulayer/bg_bottom.png");
	pBottom->setPosition(ccp(visiableSize.width/2,visiableSize.height*0.08));
	this->addChild(pBottom,1);

	CCSprite *pGridSize=CCSprite::create("gamemenulayer/bg_gridsize.png");
	pGridSize->setPosition(ccp(visiableSize.width/2,visiableSize.height*0.1));
	this->addChild(pGridSize,1);

	CCSprite *pHelp=CCSprite::create("gamemenulayer/bg_helpnum.png");
	pHelp->setPosition(ccp(visiableSize.width*0.9,visiableSize.height*0.1));
	this->addChild(pHelp,1);

	CCSprite *pTime=CCSprite::create("gamemenulayer/time.png");
	pTime->setPosition(ccp(visiableSize.width*0.2,visiableSize.height*0.9));
	this->addChild(pTime,1);

	CCSprite *pStep=CCSprite::create("gamemenulayer/step.png");
	pStep->setPosition(ccp(visiableSize.width*0.8,visiableSize.height*0.9));
	this->addChild(pStep,1);
	//ʱ
	CCString *pTimestr=CCString::createWithFormat("%d",m_Timelose);
	m_ptimelose=CCLabelTTF::create(pTimestr->getCString(),"Arial",28);
	m_ptimelose->setPosition(ccp(visiableSize.width*0.28,visiableSize.height*0.9));
	this->addChild(m_ptimelose,1);

	schedule(schedule_selector(CFlowGameMenuLayer::timelose),1.0f);  //1صʵֵʱ
	return true;
}

void CFlowGameMenuLayer::replay(CCObject *pSender)  //
{
	//m_gameScene=CCScene::create();
	//CFlowGameLayer *gamelayer=CFlowGameLayer::create();
	//m_gameScene->addChild(gamelayer);
	//CFlowGameMenuLayer *gameMenuLayer=CFlowGameMenuLayer::create();
	//m_gameScene->addChild(gameMenuLayer);
	//CCDirector::sharedDirector()->replaceScene(m_gameScene);
	//CMydata *data=new CMydata;
 //   data->ReadXmlFile();
}

void CFlowGameMenuLayer::musicControl(CCObject *pSender) //ֿ
{
	schedule(schedule_selector(CFlowGameMenuLayer::timelose),1.0f);

}


void CFlowGameMenuLayer::searchMore(CCObject *pSender)  //Ҹ
{

}


void CFlowGameMenuLayer::search(CCObject *pSender)   //
{

}


void CFlowGameMenuLayer::timelose(float fd)
{
	m_Timelose--;
	CCString *ptiemstr=CCString::createWithFormat("%d",m_Timelose);
	m_ptimelose->setString(ptiemstr->getCString());
	if (m_Timelose<=0)
	{
		//istimeOver=true;
		unschedule(schedule_selector(CFlowGameMenuLayer::timelose));
		//͸
		CFlowLoseLayer *loseLayer = CFlowLoseLayer::create();
		//ð͸λ
		loseLayer->setPosition(ccp(0,0));
		//ӵ
		this->addChild(loseLayer,8);
	}
}

