#include "FlowSectionSelectLayer.h"
#include "Mydata.h"
#include "SimpleAudioEngine.h"
extern int sectionIndex;
extern int kindIndex;
CFlowSectionSelectLayer::CFlowSectionSelectLayer(void)
{
	CCLOG("sectionSelectLayer");
}


CFlowSectionSelectLayer::~CFlowSectionSelectLayer(void)
{
}

bool CFlowSectionSelectLayer::init()
{
	bool bRet=false;
	setKeypadEnabled(true);  
	do 
	{
		CC_BREAK_IF(!CCLayer::init());
		m_nCurPage=1;
		CCSize visibleSize=CCDirector::sharedDirector()->getVisibleSize();
		CCPoint origin=CCDirector::sharedDirector()->getVisibleOrigin();
		m_pMenu=CCMenu::create();
		CCLayer *pLayer=CCLayer::create();
		m_pMenu=CCMenu::create();
		//ͼƬԴ
		int menuZorder=1;
		for (int page=1;page<=5;page++)
		{
			CCSprite *pSprite=CCSprite::create("sectionselect/bg0.jpg");
			pSprite->setPosition(ccp(origin.x+visibleSize.width*(page-0.5f),origin.y+visibleSize.height/2));
			pLayer->addChild(pSprite);
			CCString *pTitleStr=CCString::createWithFormat("sectionselect/bg_menu_title%d.png",kindIndex);
			CCSprite *title=CCSprite::create(pTitleStr->getCString());
			title->setPosition(ccp(origin.x+visibleSize.width*(page-0.5f),origin.y+visibleSize.height*0.9));
			pLayer->addChild(title);
			CCString *pTitleKindStr=CCString::createWithFormat("%dx%d",page+4,page+4);
			CCLabelTTF *titleKindText=CCLabelTTF::create(pTitleKindStr->getCString(),"Arial",28);
			titleKindText->setPosition(ccp(origin.x+visibleSize.width*(page-0.5f),origin.y+visibleSize.height*0.86));
			titleKindText->setColor(ccc3(0,175,255));
			pLayer->addChild(titleKindText);
			//ÿһҳϴ20ؿѡť
			for (int i=1;i<=5;i++)
			{
				for (int j=1;j<=4;j++)
				{
					CCMenuItemImage *section=CCMenuItemImage::create(
						"sectionselect/bg_menu_item.png",
						"sectionselect/bg_menu_item_pressed.png",
						this,
						menu_selector(CFlowSectionSelectLayer::goToGameLayer)
						);
					section->setPosition(ccp(visibleSize.width/5*j+visibleSize.width*(page-1),visibleSize.height/8*(8-(i+1))));
					m_pMenu->addChild(section,menuZorder);
					menuZorder++;
					CCString *numStr=CCString::createWithFormat("sectionselect/num%02d.png",4*(i-1)+j);
					CCSprite *pNum=CCSprite::create(numStr->getCString());
					pNum->setPosition(ccp(visibleSize.width/5*j+visibleSize.width*(page-1),visibleSize.height/8*(8-(i+1))));
					pNum->setScale(0.8);
					pLayer->addChild(pNum,3);
				}
			}
		}
		m_pMenu->setPosition(Vec2(0, 0));
		pLayer->addChild(m_pMenu,2);
		

		//ͼС
		m_pScrollView=ScrollView::create(CCSizeMake(480,800),pLayer);
		//ƫ
		m_pScrollView->setContentOffset(Vec2(0, 0));
		//ͷ
		//m_pScrollView->setDelegate(this);
		//ǷԼдϢfalseΪҪtureΪҪ
		m_pScrollView->setTouchEnabled(false);
		//Ƿܹ϶
		m_pScrollView->setBounceable(true);
		//
		m_pScrollView->setDirection(cocos2d::extension::ScrollView::Direction::HORIZONTAL);
		//С
		pLayer->setContentSize(CCSizeMake(480*5,800));
		this->addChild(m_pScrollView);

		//ӵײҳʶ
		for (int i=1;i<=5;i++)
		{
			CCSprite *pageControlSprite=CCSprite::create("sectionselect/smalldot.png");
			pageControlSprite->setPosition(
				ccp
				(
				visibleSize.width/2-3*pageControlSprite->getContentSize().width/2+pageControlSprite->getContentSize().width*(i-1),
				origin.y+30
				)
				);
			pageControlSprite->setTag(100+i);
			this->addChild(pageControlSprite,1);
		}
		//ʼ״̬һΪѡ
		CCSprite *selectedSprite=(CCSprite *)this->getChildByTag(101);
		CCTexture2D *aTexttrue=CCTextureCache::sharedTextureCache()->addImage("sectionselect/bigdot.png");
		selectedSprite->setTexture(aTexttrue);

		//֡ķʽ
		//CCSpriteFrameCache *pCache=CCSpriteFrameCache::sharedSpriteFrameCache();
		//pCache->addSpriteFrame(CCSpriteFrame::create("smalldot.png",CCRectMake(0,0,64,64)),"smalldot.png");
		//pCache->addSpriteFrame(CCSpriteFrame::create("bigdot.png",CCRectMake(0,0,64,64)),"bigdot.png");
		//for (int i=1;i<=3;i++)
		//{
		// CCSprite *pPoint = CCSprite::createWithSpriteFrameName("smalldot.png");
		// pPoint->setTag(i);
		// pPoint->setPosition(ccp( origin.x + (visibleSize.width - 3 * pPoint->getContentSize().width)/2 + pPoint->getContentSize().width * (i-1), origin.y + 30));
		// this->addChild(pPoint);
		//}
		//CCSprite *pPoint = (CCSprite *)this->getChildByTag(1);
		//pPoint->setDisplayFrame(pCache->spriteFrameByName("bigdot.png"));

		bRet=true;

	} while (0);


	return true;
}

//void CFlowSectionSelectLayer::scrollViewDidScroll(ScrollView *view){
//
//}
//void CFlowSectionSelectLayer::scrollViewDidZoom(CCScrollView *view)
//{
//
//}
void CFlowSectionSelectLayer::onEnter()
{
	CCLayer::onEnter();
	//CCDirector::sharedDirector()->getTouchDispatcher()->addTargetedDelegate(this,0,true);
	EventListenerTouchOneByOne *listener = EventListenerTouchOneByOne::create();
	listener->setSwallowTouches(true); //ݴ
	listener->onTouchBegan = CC_CALLBACK_2(CFlowSectionSelectLayer::onTouchBegan, this);
	listener->onTouchMoved = CC_CALLBACK_2(CFlowSectionSelectLayer::onTouchMoved, this);
	listener->onTouchEnded = CC_CALLBACK_2(CFlowSectionSelectLayer::onTouchEnded, this);
	listener->onTouchCancelled = CC_CALLBACK_2(CFlowSectionSelectLayer::onTouchCancelled, this);
	//
	Director::getInstance()->getEventDispatcher()->addEventListenerWithSceneGraphPriority(listener, this);

	//android back
	EventListenerKeyboard* l = EventListenerKeyboard::create();
	l->onKeyReleased = CC_CALLBACK_2(CFlowSectionSelectLayer::onKeyReleased, this);
	_eventDispatcher->addEventListenerWithSceneGraphPriority(l, this);
}
void CFlowSectionSelectLayer::onExit(){
	//CCDirector::sharedDirector()->getTouchDispatcher()->removeDelegate(this);
	CCLayer::onExit();
}
bool CFlowSectionSelectLayer::onTouchBegan(CCTouch *pTouch, CCEvent *pEvent){
	m_touchPoint=CCDirector::sharedDirector()->convertToGL(pTouch->getLocation());
	return true;
}
void CFlowSectionSelectLayer::onTouchMoved(CCTouch *pTouch, CCEvent *pEvent)
{

}
void CFlowSectionSelectLayer::onTouchEnded(CCTouch *pTouch, CCEvent *pEvent){
	CCPoint endPoint=CCDirector::sharedDirector()->convertToGL(pTouch->getLocation());
	float distance=endPoint.x-m_touchPoint.x;
	if (fabs(distance)>50)
	{
		adjustScrollView(distance);
	}

}
void CFlowSectionSelectLayer::onTouchCancelled(CCTouch *pTouch, CCEvent *pEvent){
	CCPoint endPoint=CCDirector::sharedDirector()->convertToGL(pTouch->getLocation());
	float distance=endPoint.x-m_touchPoint.x;
	if (fabs(distance)>50)
	{
		adjustScrollView(distance);
	}

}


void CFlowSectionSelectLayer::adjustScrollView(float offset){
	CCSize visibleSzie=CCDirector::sharedDirector()->getVisibleSize();
	CCPoint origin=CCDirector::sharedDirector()->getVisibleOrigin();
	//ԭʼҳҳʶΪѡ״̬

	CCSprite *pPoint=(CCSprite *)this->getChildByTag(100+m_nCurPage);
	CCTexture2D *NTexture=CCTextureCache::sharedTextureCache()->addImage("sectionselect/smalldot.png");
	pPoint->setTexture(NTexture);
	if (offset<0)
	{
		m_nCurPage++;
	}else
	{
		m_nCurPage--;
	}

	if (m_nCurPage<1)
	{
		m_nCurPage=1;
	}

	if (m_nCurPage>5)
	{
		m_nCurPage=5;
		//õǰҳҳʶΪѡ״̬
		CCSprite *selectedSprite5=(CCSprite *)this->getChildByTag(100+m_nCurPage);
		CCTexture2D *aTexture5=CCTextureCache::sharedTextureCache()->addImage("sectionselect/bigdot.png");
		selectedSprite5->setTexture(aTexture5);
	}
	else
	{
		pPoint=(CCSprite *)this->getChildByTag(m_nCurPage);
		//װɼ
		CCPoint adjustPos=ccp(origin.x-visibleSzie.width*(m_nCurPage-1),origin.y);
		m_pScrollView->setContentOffset(adjustPos,true);
		//õǰҳҳʶΪѡ״̬
		CCSprite *selectedSprite=(CCSprite *)this->getChildByTag(100+m_nCurPage);
		CCTexture2D *aTexture=CCTextureCache::sharedTextureCache()->addImage("sectionselect/bigdot.png");
		selectedSprite->setTexture(aTexture);
	}
}


void CFlowSectionSelectLayer::goToGameLayer(CCObject *pSender)
{
	CCMenuItem *pMenuItem=(CCMenuItem *)pSender;
	int nIdx=pMenuItem->getZOrder();
    sectionIndex=nIdx;
	CCLOG("sectionSelect:%d", sectionIndex);
	fm->goGameLayer();
}

void CFlowSectionSelectLayer::onKeyReleased(EventKeyboard::KeyCode keyCode, Event* event)
{
	switch (keyCode)
	{
		//ؼ       
	case EventKeyboard::KeyCode::KEY_ESCAPE:
	{
		onkeyBackClicked();
	}
	break;
	//menu        
	case EventKeyboard::KeyCode::KEY_MENU:
		break;
	}
}

void CFlowSectionSelectLayer::onkeyBackClicked()
{	
	if (CCUserDefault::sharedUserDefault()->getBoolForKey("isSoundOn"))
   {
	   CocosDenshion::SimpleAudioEngine::sharedEngine()->playEffect("music/menu.mp3");
   }
	fm->goSelectSectionLayer();
}